Attribute VB_Name = "Module1"
Option Explicit

Private Type nmhdr
  hwndFrom As Long
  idfrom As Long
  code As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type REQSIZE
    nmhdr As nmhdr
    RECT As RECT
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

' Private variables.
Private m_ReqSize As REQSIZE
Private m_nmhdr As nmhdr
Private m_OldWindowProc As Long

Private Const GWL_WNDPROC = (-4)
Private Const WM_USER = &H400
Private Const WM_NOTIFY = &H4E
Private Const SWP_NOMOVE = &H2
Private Const SWP_SHOWWINDOW = &H40
Private Const EM_GETEVENTMASK = (WM_USER + 59)
Private Const EM_SETEVENTMASK = (WM_USER + 69)
Private Const ENM_REQUESTRESIZE = &H40000
Private Const EN_REQUESTRESIZE = &H701

' Public variables.
Public g_RichWidth As Long
Public Const EM_REQUESTRESIZE = (WM_USER + 65)
Public Const VBNullPtr = 0&
Public g_RchWnd As Long
' Set a new WindowProc.
Public Sub SetWindowProc(ByVal target_hWnd As Long)
   On Error Resume Next
   m_OldWindowProc = SetWindowLong(target_hWnd, GWL_WNDPROC, AddressOf NewWindowProc)
End Sub

' Look for the WM_NOTIFY message with an
' EN_REQUESTRESIZE message.
Public Function NewWindowProc(ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error Resume Next

    ' See if this is WM_NOTIFY
    If msg = WM_NOTIFY Then
        ' Copy lParam into the nmhdr structure,
        CopyMemory m_nmhdr, ByVal lParam, Len(m_nmhdr)

        ' See if this is an EN_REQUESTRESIZE.
        If m_nmhdr.code = EN_REQUESTRESIZE Then
            ' Copy lParam into the REQSIZE structure,
            CopyMemory m_ReqSize, ByVal lParam, Len(m_ReqSize)

            ' Make the RichtextBox tall enough.
            SetWindowPos g_RchWnd, VBNullPtr, _
                0, 0, _
                g_RichWidth, m_ReqSize.RECT.Bottom - m_ReqSize.RECT.Top, _
                SWP_SHOWWINDOW Or SWP_NOMOVE
         End If
    End If ' If msg = WM_NOTIFY Then ...

    ' Call the original WindowProc.
    NewWindowProc = CallWindowProc(m_OldWindowProc, hWnd, msg, wParam, lParam)
End Function
' Restore the original WindowProc.
Public Sub RestoreWindowProc(ByVal target_hWnd As Long)
    On Error Resume Next
    SetWindowLong target_hWnd, GWL_WNDPROC, m_OldWindowProc
    m_OldWindowProc = 0
End Sub
' Set the event ENM_REQUESTRESIZE mask for this window.
Public Sub SetMask(ByVal target_hWnd As Long)
Dim mask As Long

    On Error Resume Next

    ' Get the current event mask.
    mask = SendMessage(target_hWnd, EM_GETEVENTMASK, 0, 0)

    ' Add ENM_REQUESTRESIZE.
    mask = (mask Or ENM_REQUESTRESIZE)
    SendMessage target_hWnd, EM_SETEVENTMASK, 0, ENM_REQUESTRESIZE
End Sub
